// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'HTMLStatusBar.pas' rev: 3.00

#ifndef HTMLStatusBarHPP
#define HTMLStatusBarHPP
#include <Menus.hpp>
#include <ShellAPI.hpp>
#include <Commctrl.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Htmlstatusbar
{
//-- type declarations -------------------------------------------------------
enum THTMLStatusPanelStyle { psHTML, psText, psOwnerDraw, psTime, psDate, psNumLock, psCapsLock, psScrollLock, 
	psProgress };

enum THTMLStatusPanelBevel { pbNone, pbLowered, pbRaised };

typedef void __fastcall (__closure *TAnchorClick)(System::TObject* Sender, System::AnsiString Anchor
	);

enum TProgressIndication { piPercentage, piAbsolute, piNone };

class DELPHICLASS TProgressStyle;
class DELPHICLASS THTMLStatusPanel;
class PASCALIMPLEMENTATION THTMLStatusPanel : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::AnsiString FText;
	int FWidth;
	TAlignment FAlignment;
	THTMLStatusPanelBevel FBevel;
	bool FParentBiDiMode;
	THTMLStatusPanelStyle FStyle;
	bool FUpdateNeeded;
	System::AnsiString FTimeFormat;
	System::AnsiString fDateFormat;
	System::AnsiString fHint;
	TProgressStyle* fProgressStyle;
	void __fastcall SetAlignment(Classes::TAlignment Value);
	void __fastcall SetBevel(THTMLStatusPanelBevel Value);
	void __fastcall SetParentBiDiMode(bool Value);
	void __fastcall SetStyle(THTMLStatusPanelStyle Value);
	void __fastcall SetText(const System::AnsiString Value);
	void __fastcall SetWidth(int Value);
	bool __fastcall IsBiDiModeStored(void);
	void __fastcall SetDateFormat(const System::AnsiString Value);
	void __fastcall SetTimeFormat(const System::AnsiString Value);
	void __fastcall SetProgressStyle(const TProgressStyle* Value);
	void __fastcall SetHint(const System::AnsiString Value);
	
protected:
	virtual System::AnsiString __fastcall GetDisplayName();
	
public:
	__fastcall virtual THTMLStatusPanel(Classes::TCollection* Collection);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall ParentBiDiModeChanged(void);
	bool __fastcall UseRightToLeftAlignment(void);
	bool __fastcall UseRightToLeftReading(void);
	
__published:
	__property Classes::TAlignment Alignment = {read=FAlignment, write=SetAlignment, default=0};
	__property THTMLStatusPanelBevel Bevel = {read=FBevel, write=SetBevel, default=1};
	__property bool ParentBiDiMode = {read=FParentBiDiMode, write=SetParentBiDiMode, default=1};
	__property THTMLStatusPanelStyle Style = {read=FStyle, write=SetStyle, default=1};
	__property System::AnsiString Text = {read=FText, write=SetText};
	__property int Width = {read=FWidth, write=SetWidth, nodefault};
	__property System::AnsiString DateFormat = {read=fDateFormat, write=SetDateFormat};
	__property System::AnsiString TimeFormat = {read=FTimeFormat, write=SetTimeFormat};
	__property TProgressStyle* Progress = {read=fProgressStyle, write=SetProgressStyle};
	__property System::AnsiString Hint = {read=fHint, write=SetHint};
public:
	/* TCollectionItem.Destroy */ __fastcall virtual ~THTMLStatusPanel(void) { }
	
};

class PASCALIMPLEMENTATION TProgressStyle : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int fMin;
	int fPosition;
	int fMax;
	Graphics::TColor fColor;
	TProgressIndication fIndication;
	Graphics::TColor fBackground;
	Graphics::TColor fTextColor;
	THTMLStatusPanel* fOwner;
	void __fastcall SetColor(const Graphics::TColor Value);
	void __fastcall SetIndication(const TProgressIndication Value);
	void __fastcall SetMax(const int Value);
	void __fastcall SetMin(const int Value);
	void __fastcall SetPosition(const int Value);
	void __fastcall SetBackGround(const Graphics::TColor Value);
	void __fastcall SetTextColor(const Graphics::TColor Value);
	
protected:
	void __fastcall Changed(void);
	
public:
	__fastcall TProgressStyle(THTMLStatusPanel* aOwner);
	__fastcall virtual ~TProgressStyle(void);
	
__published:
	__property Graphics::TColor Color = {read=fColor, write=SetColor, nodefault};
	__property Graphics::TColor BackGround = {read=fBackground, write=SetBackGround, nodefault};
	__property Graphics::TColor TextColor = {read=fTextColor, write=SetTextColor, nodefault};
	__property TProgressIndication Indication = {read=fIndication, write=SetIndication, nodefault};
	__property int Min = {read=fMin, write=SetMin, nodefault};
	__property int Max = {read=fMax, write=SetMax, nodefault};
	__property int Position = {read=fPosition, write=SetPosition, nodefault};
};

class DELPHICLASS THTMLStatusPanels;
class DELPHICLASS THTMLStatusBar;
typedef void __fastcall (__closure *TDrawPanelEvent)(THTMLStatusBar* StatusBar, THTMLStatusPanel* Panel
	, const Windows::TRect &Rect);

class PASCALIMPLEMENTATION THTMLStatusBar : public Controls::TWinControl 
{
	typedef Controls::TWinControl inherited;
	
private:
	THTMLStatusPanels* FPanels;
	Graphics::TCanvas* FCanvas;
	System::AnsiString FSimpleText;
	bool FSimplePanel;
	bool FSizeGrip;
	bool FUseSystemFont;
	bool FAutoHint;
	TDrawPanelEvent FOnDrawPanel;
	Classes::TNotifyEvent FOnHint;
	Graphics::TColor FURLColor;
	int fTimerID;
	int fTimerCount;
	Controls::TImageList* fImages;
	int fMousePanel;
	System::AnsiString fAnchor;
	bool fAnchorHint;
	TAnchorClick fAnchorClick;
	TAnchorClick fAnchorEnter;
	TAnchorClick fAnchorExit;
	System::AnsiString __fastcall IsAnchor(int x, int y);
	int __fastcall GetPanel(int x);
	void __fastcall DoRightToLeftAlignment(System::AnsiString &Str, Classes::TAlignment AAlignment, bool 
		ARTLAlignment);
	HIDESBASE bool __fastcall IsFontStored(void);
	void __fastcall SetPanels(THTMLStatusPanels* Value);
	void __fastcall SetSimplePanel(bool Value);
	void __fastcall UpdateSimpleText(void);
	void __fastcall SetSimpleText(const System::AnsiString Value);
	void __fastcall SetSizeGrip(bool Value);
	void __fastcall SyncToSystemFont(void);
	void __fastcall UpdatePanel(int Index, bool Repaint);
	void __fastcall UpdatePanels(bool UpdateRects, bool UpdateText);
	HIDESBASE MESSAGE void __fastcall CMColorChanged(Messages::TMessage &Message);
	MESSAGE void __fastcall CMHintShow(Messages::TMessage &Msg);
	HIDESBASE MESSAGE void __fastcall CMParentFontChanged(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMSysColorChange(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMWinIniChange(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMSysFontChanged(Messages::TMessage &Message);
	MESSAGE void __fastcall CNDrawItem(Messages::TWMDrawItem &Message);
	MESSAGE void __fastcall WMGetTextLength(Messages::TWMNoParams &Message);
	HIDESBASE MESSAGE void __fastcall WMPaint(Messages::TWMPaint &Message);
	HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	MESSAGE void __fastcall WMTimer(Messages::TWMTimer &Msg);
	void __fastcall SetUseSystemFont(const bool Value);
	void __fastcall SetImages(const Controls::TImageList* Value);
	
protected:
	virtual void __fastcall UpdateStatusBar(void);
	DYNAMIC void __fastcall ChangeScale(int M, int D);
	virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
	virtual void __fastcall CreateWnd(void);
	virtual void __fastcall DestroyWnd(void);
	virtual void __fastcall Loaded(void);
	virtual bool __fastcall DoHint(void);
	DYNAMIC void __fastcall DrawPanel(THTMLStatusPanel* Panel, const Windows::TRect &Rect);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation AOperation
		);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	
public:
	__fastcall virtual THTMLStatusBar(Classes::TComponent* AOwner);
	__fastcall virtual ~THTMLStatusBar(void);
	__property Graphics::TCanvas* Canvas = {read=FCanvas};
	
__published:
	__property bool AnchorHint = {read=fAnchorHint, write=fAnchorHint, nodefault};
	__property bool AutoHint = {read=FAutoHint, write=FAutoHint, default=0};
	__property Align ;
	__property Color ;
	__property DragCursor ;
	__property DragMode ;
	__property Enabled ;
	__property Font  = {stored=IsFontStored};
	__property Controls::TImageList* Images = {read=fImages, write=SetImages};
	__property THTMLStatusPanels* Panels = {read=FPanels, write=SetPanels};
	__property ParentColor ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property bool SimplePanel = {read=FSimplePanel, write=SetSimplePanel, nodefault};
	__property System::AnsiString SimpleText = {read=FSimpleText, write=SetSimpleText};
	__property bool SizeGrip = {read=FSizeGrip, write=SetSizeGrip, default=1};
	__property Graphics::TColor URLColor = {read=FURLColor, write=FURLColor, nodefault};
	__property bool UseSystemFont = {read=FUseSystemFont, write=SetUseSystemFont, default=1};
	__property Visible ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property Classes::TNotifyEvent OnHint = {read=FOnHint, write=FOnHint};
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property TDrawPanelEvent OnDrawPanel = {read=FOnDrawPanel, write=FOnDrawPanel};
	__property OnStartDrag ;
	__property TAnchorClick OnAnchorClick = {read=fAnchorClick, write=fAnchorClick};
	__property TAnchorClick OnAnchorEnter = {read=fAnchorEnter, write=fAnchorEnter};
	__property TAnchorClick OnAnchorExit = {read=fAnchorExit, write=fAnchorExit};
public:
	/* TWinControl.CreateParented */ __fastcall THTMLStatusBar(HWND ParentWindow) : Controls::TWinControl(
		ParentWindow) { }
	
};

class PASCALIMPLEMENTATION THTMLStatusPanels : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	THTMLStatusBar* FStatusBar;
	HIDESBASE THTMLStatusPanel* __fastcall GetItem(int Index);
	HIDESBASE void __fastcall SetItem(int Index, THTMLStatusPanel* Value);
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	virtual void __fastcall Update(Classes::TCollectionItem* Item);
	
public:
	__fastcall THTMLStatusPanels(THTMLStatusBar* StatusBar);
	HIDESBASE THTMLStatusPanel* __fastcall Add(void);
	__property THTMLStatusPanel* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
public:
	/* TCollection.Destroy */ __fastcall virtual ~THTMLStatusPanels(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Htmlstatusbar */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Htmlstatusbar;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// HTMLStatusBar
